# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Docker.gitlab-ci.yml

# Build a Docker image with CI/CD and push to the GitLab registry.
# Docker-in-Docker documentation: https://docs.gitlab.com/ee/ci/docker/using_docker_build.html
#
# This template uses one generic job with conditional builds
# for the default branch and all other (MR) branches.

stages:
  - build
  - badges

build-container:
  # Use the official docker image.
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY
  # Default branch leaves tag empty (= latest tag)
  # All other branches are tagged with the escaped branch name (commit ref slug)
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - docker build --pull -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"
    # Push image to docker.io aka "Docker Hub"
    - CI_REGISTRY_IMAGE_EXT=briezh/holdingnuts_server
    - echo "$CI_REGISTRY_PASSWORD_DOCKERHUB" | docker login -u "$CI_REGISTRY_USER_DOCKERHUB" --password-stdin $CI_REGISTRY_DOCKERHUB
    - docker image tag "$CI_REGISTRY_IMAGE${tag}" "${CI_REGISTRY_IMAGE_EXT}${tag}"
    - docker push "${CI_REGISTRY_IMAGE_EXT}${tag}"
  # Run this job in a branch where a Dockerfile exists
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile

build-badges:
  stage: build
  image: python:latest
  only:
    - master
    - main
  before_script:
    - python -V
    - pip install -r python/requirements.txt
  script:
    - anybadge -l "Image Size"   --file=size.svg  --color=green --value "https://badgen.net/docker/pulls/${CI_REGISTRY_USER_DOCKERHUB}/${CI_PROJECT_NAME}?icon=docker&label=image%20size"
    - anybadge -l "Docker Pulls" --file=pulls.svg --color=green --value "https://badgen.net/docker/pulls/${CI_REGISTRY_USER_DOCKERHUB}/${CI_PROJECT_NAME}?icon=docker&label=pulls"
    - anybadge -l "Docker Stars" --file=stars.svg --color=green --value "https://badgen.net/docker/pulls/${CI_REGISTRY_USER_DOCKERHUB}/${CI_PROJECT_NAME}?icon=docker&label=stars"
    - mkdir -p .badges
    - cp *.svg .badges
    - mv .badges badges
  artifacts:
    paths:
      - badges
